## intel-ipsec-mb 0.53

=== Makefile ===
#
# Copyright (c) 2012-2019, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Intel Corporation nor the names of its contributors
#       may be used to endorse or promote products derived from this software
#       without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

LIB = libIPSec_MB
SHARED ?= y
IMB_HDR = intel-ipsec-mb.h

# Detect library version
IMB_VERSION = $(shell grep -e "IMB_VERSION_STR" $(IMB_HDR) | cut -d'"' -f2)
ifeq ($(IMB_VERSION),)
$(error "Failed to detect library version!")
endif

VERSION = $(shell echo $(IMB_VERSION) | cut -d. -f1-3)
SO_VERSION = $(shell echo $(VERSION) | cut -d. -f1)

PREFIX ?= /usr
LIB_INSTALL_DIR ?= $(PREFIX)/lib
HDR_DIR ?= $(PREFIX)/include
MAN_DIR ?= $(PREFIX)/man/man7
MAN1 = libipsec-mb.7
MAN2 = libipsec-mb-dev.7
NOLDCONFIG ?= n

USE_YASM ?= n
YASM ?= yasm
NASM ?= nasm

OBJ_DIR = obj

INCLUDE_DIRS := include . no-aesni
INCLUDES := $(foreach i,$(INCLUDE_DIRS),-I $i)

CC ?= gcc

CFLAGS := -DLINUX $(EXTRA_CFLAGS) $(INCLUDES) \
	-W -Wall -Wextra -Wmissing-declarations -Wpointer-arith \
	-Wcast-qual -Wundef -Wwrite-strings  \
	-Wformat -Wformat-security \
	-Wunreachable-code -Wmissing-noreturn -Wsign-compare -Wno-endif-labels \
	-Wstrict-prototypes -Wmissing-prototypes -Wold-style-definition \
	-fno-strict-overflow -fno-delete-null-pointer-checks -fwrapv

ASM_INCLUDE_DIRS := .

YASM_INCLUDES := $(foreach i,$(ASM_INCLUDE_DIRS),-I $i)
YASM_FLAGS := -f x64 -f elf64 -X gnu -g dwarf2 -DLINUX -D__linux__ $(YASM_INCLUDES)

NASM_INCLUDES := $(foreach i,$(ASM_INCLUDE_DIRS),-I$i/)
NASM_FLAGS := -felf64 -Xgnu -gdwarf -DLINUX -D__linux__ $(NASM_INCLUDES)

ifeq ($(DEBUG),y)
CFLAGS += -g -DDEBUG
OPT = -O0
LDFLAGS += -g
else
OPT = -O3
CFLAGS += -fstack-protector -D_FORTIFY_SOURCE=2
endif

ifeq ($(SAFE_DATA),y)
CFLAGS += -DSAFE_DATA
NASM_FLAGS += -DSAFE_DATA
YASM_FLAGS += -DSAFE_DATA
endif

ifeq ($(SAFE_PARAM),y)
CFLAGS += -DSAFE_PARAM
NASM_FLAGS += -DSAFE_PARAM
YASM_FLAGS += -DSAFE_PARAM
endif

ifneq ($(SAFE_LOOKUP),n)
CFLAGS += -DSAFE_LOOKUP
NASM_FLAGS += -DSAFE_LOOKUP
YASM_FLAGS += -DSAFE_LOOKUP
endif

# prevent SIMD optimizations for non-aesni modules
CFLAGS_NO_SIMD = $(CFLAGS) -O1
CFLAGS += $(OPT)

# Set architectural optimizations for GCC/CC
ifeq ($(CC),$(filter $(CC),gcc cc))
GCC_VERSION = $(shell $(CC) -dumpversion | cut -d. -f1)
GCC_GE_V5 = $(shell [ $(GCC_VERSION) -ge 5 ] && echo true)
ifeq ($(GCC_GE_V5),true)
OPT_SSE = -march=nehalem -maes
OPT_AVX = -march=sandybridge -maes
OPT_AVX2 = -march=haswell -maes
OPT_AVX512 = -march=broadwell
OPT_NOAESNI = -march=nehalem
endif
endif

# so or static build
ifeq ($(SHARED),y)
CFLAGS += -fPIC
LIBNAME = $(LIB).so.$(VERSION)
LIBPERM = 0755
LDFLAGS += -z noexecstack -z relro -z now
else
CFLAGS += -fPIE
LIBNAME = $(LIB).a
LIBPERM = 0644
LDFLAGS += -g
endif

# warning messages
SAFE_PARAM_MSG1="SAFE_PARAM option not set."
SAFE_PARAM_MSG2="Input parameters will not be checked."
SAFE_DATA_MSG1="SAFE_DATA option not set."
SAFE_DATA_MSG2="Stack and registers containing sensitive information, \
		such keys or IV will not be cleared \
		at the end of function calls."
SAFE_LOOKUP_MSG1="SAFE_LOOKUP option not set."
SAFE_LOOKUP_MSG2="Lookups which depend on sensitive information \
		are not guaranteed to be done in constant time."

ifeq ($(GCM_BIG_DATA),y)
CFLAGS += -DGCM_BIG_DATA
NASM_FLAGS += -DGCM_BIG_DATA
YASM_FLAGS += -DGCM_BIG_DATA
endif

#
# List of C modules (any origin)
#
c_lib_objs := \
	mb_mgr_avx.o \
	mb_mgr_avx2.o \
	mb_mgr_avx512.o \
	mb_mgr_sse.o \
	mb_mgr_sse_no_aesni.o \
	alloc.o \
	aes_xcbc_expand_key.o \
	md5_one_block.o \
	sha_one_block.o \
	des_key.o \
	des_basic.o \
	version.o \
	cpu_feature.o \
	aesni_emu.o \
	kasumi_avx.o \
	kasumi_iv.o \
	kasumi_sse.o \
	zuc_sse_top.o \
	zuc_avx_top.o \
	zuc_iv.o \
	snow3g_sse.o \
	snow3g_sse_no_aesni.o \
	snow3g_avx.o \
	snow3g_avx2.o \
	snow3g_tables.o \
	snow3g_iv.o

#
# List of ASM modules (root directory/common)
#
asm_generic_lib_objs := \
	aes_keyexp_128.o \
	aes_keyexp_192.o \
	aes_keyexp_256.o \
	aes_cmac_subkey_gen.o \
	save_xmms.o \
	clear_regs_mem_fns.o \
	const.o \
	aes128_ecbenc_x3.o \
	zuc_common.o \
	wireless_common.o \
	constant_lookup.o

#
# List of ASM modules (no-aesni directory)
#
asm_noaesni_lib_objs := \
	aes128_cbc_dec_by4_sse_no_aesni.o \
	aes192_cbc_dec_by4_sse_no_aesni.o \
	aes256_cbc_dec_by4_sse_no_aesni.o \
	aes_cbc_enc_128_x4_no_aesni.o \
	aes_cbc_enc_192_x4_no_aesni.o \
	aes_cbc_enc_256_x4_no_aesni.o \
	aes128_cntr_by4_sse_no_aesni.o \
	aes192_cntr_by4_sse_no_aesni.o \
	aes256_cntr_by4_sse_no_aesni.o \
	aes_ecb_by4_sse_no_aesni.o \
	aes128_cntr_ccm_by4_sse_no_aesni.o \
	pon_sse_no_aesni.o \
	aes_cfb_128_sse_no_aesni.o \
	aes128_cbc_mac_x4_no_aesni.o \
	aes_xcbc_mac_128_x4_no_aesni.o \
	mb_mgr_aes_flush_sse_no_aesni.o \
	mb_mgr_aes_submit_sse_no_aesni.o \
	mb_mgr_aes192_flush_sse_no_aesni.o \
	mb_mgr_aes192_submit_sse_no_aesni.o \
	mb_mgr_aes256_flush_sse_no_aesni.o \
	mb_mgr_aes256_submit_sse_no_aesni.o \
	mb_mgr_aes_cmac_submit_flush_sse_no_aesni.o \
	mb_mgr_aes_ccm_auth_submit_flush_sse_no_aesni.o \
	mb_mgr_aes_xcbc_flush_sse_no_aesni.o \
	mb_mgr_aes_xcbc_submit_sse_no_aesni.o

#
# List of ASM modules (sse directory)
#
asm_sse_lib_objs := \
	aes128_cbc_dec_by4_sse.o \
	aes192_cbc_dec_by4_sse.o \
	aes256_cbc_dec_by4_sse.o \
	aes_cbc_enc_128_x4.o \
	aes_cbc_enc_192_x4.o \
	aes_cbc_enc_256_x4.o \
	pon_sse.o \
	aes128_cntr_by4_sse.o \
	aes192_cntr_by4_sse.o \
	aes256_cntr_by4_sse.o \
	aes_ecb_by4_sse.o \
	aes128_cntr_ccm_by4_sse.o \
	aes_cfb_128_sse.o \
	aes128_cbc_mac_x4.o \
	aes_xcbc_mac_128_x4.o \
	md5_x4x2_sse.o \
	sha1_mult_sse.o \
	sha1_one_block_sse.o \
	sha224_one_block_sse.o \
	sha256_one_block_sse.o \
	sha384_one_block_sse.o \
	sha512_one_block_sse.o \
	sha512_x2_sse.o \
	sha_256_mult_sse.o \
	sha1_ni_x2_sse.o \
	sha256_ni_x2_sse.o \
	zuc_sse.o \
	mb_mgr_aes_flush_sse.o \
	mb_mgr_aes_submit_sse.o \
	mb_mgr_aes192_flush_sse.o \
	mb_mgr_aes192_submit_sse.o \
	mb_mgr_aes256_flush_sse.o \
	mb_mgr_aes256_submit_sse.o \
	mb_mgr_aes_cmac_submit_flush_sse.o \
	mb_mgr_aes_ccm_auth_submit_flush_sse.o \
	mb_mgr_aes_xcbc_flush_sse.o \
	mb_mgr_aes_xcbc_submit_sse.o \
	mb_mgr_hmac_md5_flush_sse.o \
	mb_mgr_hmac_md5_submit_sse.o \
	mb_mgr_hmac_flush_sse.o \
	mb_mgr_hmac_submit_sse.o \
	mb_mgr_hmac_sha_224_flush_sse.o \
	mb_mgr_hmac_sha_224_submit_sse.o \
	mb_mgr_hmac_sha_256_flush_sse.o \
	mb_mgr_hmac_sha_256_submit_sse.o \
	mb_mgr_hmac_sha_384_flush_sse.o \
	mb_mgr_hmac_sha_384_submit_sse.o \
	mb_mgr_hmac_sha_512_flush_sse.o \
	mb_mgr_hmac_sha_512_submit_sse.o \
	mb_mgr_hmac_flush_ni_sse.o \
	mb_mgr_hmac_submit_ni_sse.o \
	mb_mgr_hmac_sha_224_flush_ni_sse.o \
	mb_mgr_hmac_sha_224_submit_ni_sse.o \
	mb_mgr_hmac_sha_256_flush_ni_sse.o \
	mb_mgr_hmac_sha_256_submit_ni_sse.o

#
# List of ASM modules (avx directory)
#
asm_avx_lib_objs := \
	aes_cbc_enc_128_x8.o \
	aes_cbc_enc_192_x8.o \
	aes_cbc_enc_256_x8.o \
	aes128_cbc_dec_by8_avx.o \
	aes192_cbc_dec_by8_avx.o \
	aes256_cbc_dec_by8_avx.o \
	pon_avx.o \
	aes128_cntr_by8_avx.o \
	aes192_cntr_by8_avx.o \
	aes256_cntr_by8_avx.o \
	aes128_cntr_ccm_by8_avx.o \
	aes_ecb_by4_avx.o \
	aes_cfb_128_avx.o \
	aes128_cbc_mac_x8.o \
	aes_xcbc_mac_128_x8.o \
	md5_x4x2_avx.o \
	sha1_mult_avx.o \
	sha1_one_block_avx.o \
	sha224_one_block_avx.o \
	sha256_one_block_avx.o \
	sha_256_mult_avx.o \
	sha384_one_block_avx.o \
	sha512_one_block_avx.o \
	sha512_x2_avx.o \
	zuc_avx.o \
	mb_mgr_aes_flush_avx.o \
	mb_mgr_aes_submit_avx.o \
	mb_mgr_aes192_flush_avx.o \
	mb_mgr_aes192_submit_avx.o \
	mb_mgr_aes256_flush_avx.o \
	mb_mgr_aes256_submit_avx.o \
	mb_mgr_aes_cmac_submit_flush_avx.o\
	mb_mgr_aes_ccm_auth_submit_flush_avx.o \
	mb_mgr_aes_xcbc_flush_avx.o \
	mb_mgr_aes_xcbc_submit_avx.o \
	mb_mgr_hmac_md5_flush_avx.o \
	mb_mgr_hmac_md5_submit_avx.o \
	mb_mgr_hmac_flush_avx.o \
	mb_mgr_hmac_submit_avx.o \
	mb_mgr_hmac_sha_224_flush_avx.o \
	mb_mgr_hmac_sha_224_submit_avx.o \
	mb_mgr_hmac_sha_256_flush_avx.o \
	mb_mgr_hmac_sha_256_submit_avx.o \
	mb_mgr_hmac_sha_384_flush_avx.o \
	mb_mgr_hmac_sha_384_submit_avx.o \
	mb_mgr_hmac_sha_512_flush_avx.o \
	mb_mgr_hmac_sha_512_submit_avx.o

#
# List of ASM modules (avx2 directory)
#
asm_avx2_lib_objs := \
	md5_x8x2_avx2.o \
	sha1_x8_avx2.o \
	sha256_oct_avx2.o \
	sha512_x4_avx2.o \
	mb_mgr_hmac_md5_flush_avx2.o \
	mb_mgr_hmac_md5_submit_avx2.o \
	mb_mgr_hmac_flush_avx2.o \
	mb_mgr_hmac_submit_avx2.o \
	mb_mgr_hmac_sha_224_flush_avx2.o \
	mb_mgr_hmac_sha_224_submit_avx2.o \
	mb_mgr_hmac_sha_256_flush_avx2.o \
	mb_mgr_hmac_sha_256_submit_avx2.o \
	mb_mgr_hmac_sha_384_flush_avx2.o \
	mb_mgr_hmac_sha_384_submit_avx2.o \
	mb_mgr_hmac_sha_512_flush_avx2.o \
	mb_mgr_hmac_sha_512_submit_avx2.o

#
# List of ASM modules (avx512 directory)
#
asm_avx512_lib_objs := \
	sha1_x16_avx512.o \
	sha256_x16_avx512.o \
	sha512_x8_avx512.o \
	des_x16_avx512.o \
	cntr_vaes_avx512.o \
	aes_cbc_dec_vaes_avx512.o \
	aes_cbc_enc_vaes_avx512.o \
	mb_mgr_aes_submit_avx512.o \
	mb_mgr_aes_flush_avx512.o \
	mb_mgr_aes192_submit_avx512.o \
	mb_mgr_aes192_flush_avx512.o \
	mb_mgr_aes256_submit_avx512.o \
	mb_mgr_aes256_flush_avx512.o \
	mb_mgr_hmac_flush_avx512.o \
	mb_mgr_hmac_submit_avx512.o \
	mb_mgr_hmac_sha_224_flush_avx512.o \
	mb_mgr_hmac_sha_224_submit_avx512.o \
	mb_mgr_hmac_sha_256_flush_avx512.o \
	mb_mgr_hmac_sha_256_submit_avx512.o \
	mb_mgr_hmac_sha_384_flush_avx512.o \
	mb_mgr_hmac_sha_384_submit_avx512.o \
	mb_mgr_hmac_sha_512_flush_avx512.o \
	mb_mgr_hmac_sha_512_submit_avx512.o \
	mb_mgr_des_avx512.o

#
# GCM object file lists
#

c_gcm_objs := gcm.o

asm_noaesni_gcm_objs := \
	gcm128_sse_no_aesni.o gcm192_sse_no_aesni.o gcm256_sse_no_aesni.o

asm_sse_gcm_objs := \
	gcm128_sse.o gcm192_sse.o gcm256_sse.o

asm_avx_gcm_objs := \
	gcm128_avx_gen2.o gcm192_avx_gen2.o gcm256_avx_gen2.o

asm_avx2_gcm_objs := \
	gcm128_avx_gen4.o gcm192_avx_gen4.o gcm256_avx_gen4.o

asm_avx512_gcm_objs := \
	gcm128_vaes_avx512.o gcm192_vaes_avx512.o gcm256_vaes_avx512.o \
	gcm128_avx512.o gcm192_avx512.o gcm256_avx512.o

#
# build object files lists for GCM and NO-GCM variants
#
ifeq ($(NO_GCM), y)
CFLAGS += -DNO_GCM
asm_obj_files := $(asm_generic_lib_objs) $(asm_noaesni_lib_objs) \
	$(asm_sse_lib_objs) $(asm_avx_lib_objs) \
	$(asm_avx2_lib_objs) $(asm_avx512_lib_objs)
c_obj_files := $(c_lib_objs)
else
asm_obj_files := $(asm_generic_lib_objs) \
	$(asm_noaesni_lib_objs) $(asm_noaesni_gcm_objs) \
	$(asm_sse_lib_objs) $(asm_sse_gcm_objs) \
	$(asm_avx_lib_objs) $(asm_avx_gcm_objs) \
	$(asm_avx2_lib_objs) $(asm_avx2_gcm_objs) \
	$(asm_avx512_lib_objs) $(asm_avx512_gcm_objs)
c_obj_files := $(c_lib_objs) $(c_gcm_objs)
endif

#
# aggregate all objects files together and prefix with OBJDIR
#
lib_obj_files := $(asm_obj_files) $(c_obj_files)

=== debian/changelog ===
intel-ipsec-mb (0.53-1) unstable; urgency=medium

  * Sync to latest 0.53 release
  * Update debian/compat to level 12
  * Remove a space from previous changelong entry

 -- Colin Ian King <colin.king@canonical.com>  Thu, 7 Nov 2019 16:57:22 +0000

=== debian/control ===
Source: intel-ipsec-mb
Section: utils
Priority: optional
Maintainer: Colin Ian King <colin.king@canonical.com>
Uploaders: Kamal Mostafa <kamal@whence.com>
Build-Depends: debhelper (>= 12), nasm
Standards-Version: 4.1.2
Homepage: https://github.com/intel/intel-ipsec-mb

Package: libipsec-mb0
Section: libs
Architecture: amd64
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Intel(R) Multi-Buffer Crypto for IPSec library
 Libipsec-mb is highly-optimized software implementations of
 the core cryptographic processing for IPsec, which provides
 industry-leading performance on a range of Intel(R) Processors.

Package: libipsec-mb-dev
Section: libdevel
Architecture: linux-amd64
Priority: optional
Depends: ${misc:Depends}, libipsec-mb0 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: Development files for Intel(R) Multi-Buffer Crypto for IPSec library
 Libipsec-mb is highly-optimized software implementations of
 the core cryptographic processing for IPsec, which provides
 industry-leading performance on a range of Intel(R) Processors.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

DESTDIR=$$(pwd)/debian/tmp
LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
HDRDIR=/usr/include
MANDIR=/usr/share/man/man7

VERSION_MAJOR=$(shell grep -e "IMB_VERSION_STR" intel-ipsec-mb.h | cut -d'"' -f2 | cut -d'.' -f1)
VERSION_MINOR=$(shell grep -e "IMB_VERSION_STR" intel-ipsec-mb.h | cut -d'"' -f2 | cut -d'.' -f2)
VERSION_PATCH=$(shell grep -e "IMB_VERSION_STR" intel-ipsec-mb.h | cut -d'"' -f2 | cut -d'.' -f3)

MAN1 = libipsec-mb.7
MAN2 = libipsec-mb-dev.7

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

override_dh_auto_build:
	$(shell dpkg-buildflags --export=sh); SHARED=y dh_auto_build
	rm obj/*.o
	$(shell dpkg-buildflags --export=sh); SHARED=n dh_auto_build

override_dh_auto_install:
	# Install the library
	install -d ${DESTDIR}${LIBDIR}
	install -m 0644 $$(pwd)/libIPSec_MB.a ${DESTDIR}${LIBDIR}
	install -m 0644 $$(pwd)/libIPSec_MB.so.${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH} ${DESTDIR}${LIBDIR}
	ln -s ${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH} ${DESTDIR}${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR}
	ln -s ${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR} ${DESTDIR}${LIBDIR}/libIPSec_MB.so

	#dpkg-shlibdeps ${DESTDIR}${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR}.${VERSION_MINOR}

	# Install the header files
	install -d ${DESTDIR}${HDRDIR}
	install -m 0644 $$(pwd)/intel-ipsec-mb.h ${DESTDIR}${HDRDIR}

	# Install man pages
	install -d ${DESTDIR}${MANDIR}
	install -m 0444 $$(pwd)/${MAN1} ${DESTDIR}${MANDIR}
	install -m 0444 $$(pwd)/${MAN2} ${DESTDIR}${MANDIR}

override_dh_dwz:

%:
	dh $@
	dh_makeshlibs
	dh_shlibdeps

## intel-ipsec-mb 0.55

=== Makefile ===
#
# Copyright (c) 2020, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Intel Corporation nor the names of its contributors
#       may be used to endorse or promote products derived from this software
#       without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

.PHONY: all clean style install uninstall help TAGS

all:
	$(MAKE) -C lib
	$(MAKE) -C test
	$(MAKE) -C perf

clean:
	$(MAKE) -C lib clean
	$(MAKE) -C test clean
	$(MAKE) -C perf clean

style:
	$(MAKE) -C lib style
	$(MAKE) -C test style
	$(MAKE) -C perf style

install:
	$(MAKE) -C lib install

uninstall:
	$(MAKE) -C lib uninstall

help:
	$(MAKE) -C lib help

README: README.md
	pandoc -f markdown -t plain $< -o $@

.PHONY: TAGS
TAGS:
	find ./ -name "*.[ch]" -print | etags -
	find ./ -name '*.asm'  | etags -a -
	find ./ -name '*.inc'  | etags -a -

# Check spelling in the code with codespell.
# See https://github.com/codespell-project/codespell for more details.
# Codespell options explained:
# -d        -- disable colours (emacs colours it anyway)
# -L        -- List of words to be ignored
# -S <skip> -- skip file types
# -I FILE   -- File containing words to be ignored
#
CODESPELL ?= codespell
CS_IGNORE_WORDS ?= iinclude,struc,fo,ue,od,ba

.PHONY: spellcheck
spellcheck:
	$(CODESPELL) -d -L $(CS_IGNORE_WORDS) \
	-S "*.obj,*.o,*.a,*.so,*.lib,*~,*.so,*.so.*,*.d,ipsec_perf" \
	-S "ipsec_MB_testapp,ipsec_xvalid_test" \
	./lib ./perf ./test README README.md SECURITY.md CONTRIBUTING \
	Makefile win_x64.mak ReleaseNotes.txt LICENSE $(CS_EXTRA_OPTS)

=== lib/Makefile ===
#
# Copyright (c) 2012-2020, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Intel Corporation nor the names of its contributors
#       may be used to endorse or promote products derived from this software
#       without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

LIB = libIPSec_MB
SHARED ?= y
IMB_HDR = intel-ipsec-mb.h

# Detect library version
IMB_VERSION = $(shell grep -e "IMB_VERSION_STR" $(IMB_HDR) | cut -d'"' -f2)
ifeq ($(IMB_VERSION),)
$(error "Failed to detect library version!")
endif

VERSION = $(shell echo $(IMB_VERSION) | cut -d. -f1-3)
SO_VERSION = $(shell echo $(VERSION) | cut -d. -f1)

PREFIX ?= /usr
LIB_INSTALL_DIR ?= $(PREFIX)/lib
HDR_DIR ?= $(PREFIX)/include
MAN_DIR ?= $(PREFIX)/man/man7
MAN1 = libipsec-mb.7
MAN2 = libipsec-mb-dev.7
NOLDCONFIG ?= n

USE_YASM ?= n
YASM ?= yasm
NASM ?= nasm

# Detect NASM version (minimum version required: 2.14)
NASM_VERSION = $(shell nasm -v | cut -d " " -f 3)

NASM_MAJOR_REQ = 2
NASM_MINOR_REQ = 14

ifeq ($(NASM_VERSION),)
$(error "NASM is not installed! Minimum required version: $(NASM_MAJOR_REQ).$(NASM_MINOR_REQ)")
else
NASM_MAJOR_VER = $(shell echo $(NASM_VERSION) | cut -d "." -f 1)
NASM_MINOR_VER = $(shell echo $(NASM_VERSION) | cut -d "." -f 2 | cut -c 1-2)
NASM_GE_MAJOR = $(shell [ $(NASM_MAJOR_VER) -ge $(NASM_MAJOR_REQ) ] && echo true)
NASM_GE_MINOR = $(shell [ $(NASM_MINOR_VER) -ge $(NASM_MINOR_REQ) ] && echo true)
ifneq ($(NASM_GE_MAJOR),true)
$(warning "NASM version found: $(NASM_VERSION)")
$(error "Minimum required: $(NASM_MAJOR_REQ).$(NASM_MINOR_REQ)")
endif
ifneq ($(NASM_GE_MINOR),true)
$(warning "NASM version found: $(NASM_VERSION)")
$(error "Minimum required: $(NASM_MAJOR_REQ).$(NASM_MINOR_REQ)")
endif
endif

OBJ_DIR ?= obj
LIB_DIR ?= .

INCLUDE_DIRS := include . no-aesni
INCLUDES := $(foreach i,$(INCLUDE_DIRS),-I $i)

CC ?= gcc

CFLAGS := -DLINUX $(EXTRA_CFLAGS) $(INCLUDES) \
	-W -Wall -Wextra -Wmissing-declarations -Wpointer-arith \
	-Wcast-qual -Wundef -Wwrite-strings  \
	-Wformat -Wformat-security \
	-Wunreachable-code -Wmissing-noreturn -Wsign-compare -Wno-endif-labels \
	-Wstrict-prototypes -Wmissing-prototypes -Wold-style-definition \
	-fno-strict-overflow -fno-delete-null-pointer-checks -fwrapv

ASM_INCLUDE_DIRS := .

YASM_INCLUDES := $(foreach i,$(ASM_INCLUDE_DIRS),-I $i)
YASM_FLAGS := -f x64 -f elf64 -X gnu -g dwarf2 -DLINUX -D__linux__ $(YASM_INCLUDES)

NASM_INCLUDES := $(foreach i,$(ASM_INCLUDE_DIRS),-I$i/)
NASM_FLAGS := -felf64 -Xgnu -gdwarf -DLINUX -D__linux__ $(NASM_INCLUDES)

DEBUG_OPT ?= -O0
ifeq ($(DEBUG),y)
CFLAGS += -g -DDEBUG
OPT = $(DEBUG_OPT)
LDFLAGS += -g
else
OPT = -O3
CFLAGS += -fstack-protector -D_FORTIFY_SOURCE=2
endif

ifneq ($(SAFE_DATA),n)
CFLAGS += -DSAFE_DATA
NASM_FLAGS += -DSAFE_DATA
YASM_FLAGS += -DSAFE_DATA
endif

ifneq ($(SAFE_PARAM),n)
CFLAGS += -DSAFE_PARAM
NASM_FLAGS += -DSAFE_PARAM
YASM_FLAGS += -DSAFE_PARAM
endif

ifneq ($(SAFE_LOOKUP),n)
CFLAGS += -DSAFE_LOOKUP
NASM_FLAGS += -DSAFE_LOOKUP
YASM_FLAGS += -DSAFE_LOOKUP
endif

# prevent SIMD optimizations for non-aesni modules
CFLAGS_NO_SIMD = $(CFLAGS) -O1
CFLAGS += $(OPT)

# Set generic architectural optimizations
OPT_SSE := -msse4.2 -maes -mpclmul
OPT_AVX := -mavx -maes -mpclmul
OPT_AVX2 := -mavx2 -maes -mpclmul
OPT_AVX512 := -mavx2 -maes -mpclmul # -mavx512f is not available until gcc 4.9
OPT_NOAESNI := -msse4.2 -mno-aes -mno-pclmul

# Set architectural optimizations for GCC/CC
ifeq ($(CC),$(filter $(CC),gcc cc))
GCC_VERSION = $(shell $(CC) -dumpversion | cut -d. -f1)
GCC_GE_V5 = $(shell [ $(GCC_VERSION) -ge 5 ] && echo true)
ifeq ($(GCC_GE_V5),true)
OPT_SSE := -march=nehalem -maes -mpclmul
OPT_AVX := -march=sandybridge -maes -mpclmul
OPT_AVX2 := -march=haswell -maes -mpclmul
OPT_AVX512 := -march=broadwell -maes -mpclmul
OPT_NOAESNI := -march=nehalem -mno-pclmul
endif
endif

# Set architectural optimizations for clang
ifeq ($(CC),$(filter $(CC),clang))
CLANG_VERSION = $(shell $(CC) --version | head -n 1 | cut -d ' ' -f 3)
CLANG_GE_V381 = $(shell test "$(CLANG_VERSION)" \> "3.8.0" && echo true)
ifeq ($(CLANG_GE_V381),true)
OPT_SSE := -march=nehalem -maes -mpclmul
OPT_AVX := -march=sandybridge -maes -mpclmul
OPT_AVX2 := -march=haswell -maes -mpclmul
OPT_AVX512 := -march=broadwell -maes -mpclmul
endif
# remove CFLAGS that clang warns about
CFLAGS := $(subst -fno-delete-null-pointer-checks,,$(CFLAGS))
CFLAGS := $(subst -fno-strict-overflow,,$(CFLAGS))
endif

# so or static build
ifeq ($(SHARED),y)
CFLAGS += -fPIC
LIBNAME = $(LIB).so.$(VERSION)
LIBPERM = 0755
LDFLAGS += -z noexecstack -z relro -z now
else
CFLAGS += -fPIE
LIBNAME = $(LIB).a
LIBPERM = 0644
LDFLAGS += -g
endif

# warning messages
SAFE_PARAM_MSG1="SAFE_PARAM option not set."
SAFE_PARAM_MSG2="Input parameters will not be checked."
SAFE_DATA_MSG1="SAFE_DATA option not set."
SAFE_DATA_MSG2="Stack and registers containing sensitive information, \
		such keys or IV will not be cleared \
		at the end of function calls."
SAFE_LOOKUP_MSG1="SAFE_LOOKUP option not set."
SAFE_LOOKUP_MSG2="Lookups which depend on sensitive information \
		are not guaranteed to be done in constant time."

#
# List of C modules (any origin)
#
c_lib_objs := \
	mb_mgr_avx.o \
	mb_mgr_avx2.o \
	mb_mgr_avx512.o \
	mb_mgr_sse.o \
	mb_mgr_sse_no_aesni.o \
	alloc.o \
	aes_xcbc_expand_key.o \
	md5_one_block.o \
	sha_one_block.o \
	des_key.o \
	des_basic.o \
	version.o \
	cpu_feature.o \
	aesni_emu.o \
	kasumi_avx.o \
	kasumi_iv.o \
	kasumi_sse.o \
	zuc_sse_top.o \
	zuc_sse_no_aesni_top.o \
	zuc_avx_top.o \
	zuc_avx2_top.o \
	zuc_avx512_top.o \
	zuc_iv.o \
	snow3g_sse.o \
	snow3g_sse_no_aesni.o \
	snow3g_avx.o \
	snow3g_avx2.o \
	snow3g_tables.o \
	snow3g_iv.o \
	mb_mgr_auto.o \
	error.o

#
# List of ASM modules (root directory/common)
#
asm_generic_lib_objs := \
	aes_keyexp_128.o \
	aes_keyexp_192.o \
	aes_keyexp_256.o \
	aes_cmac_subkey_gen.o \
	save_xmms.o \
	clear_regs_mem_fns.o \
	const.o \
	aes128_ecbenc_x3.o \
	zuc_common.o \
	wireless_common.o \
	constant_lookup.o \
	crc32_refl_const.o \
	crc32_const.o \
	poly1305.o \
	chacha20_poly1305.o

#
# List of ASM modules (no-aesni directory)
#
asm_noaesni_lib_objs := \
	aes128_cbc_dec_by4_sse_no_aesni.o \
	aes192_cbc_dec_by4_sse_no_aesni.o \
	aes256_cbc_dec_by4_sse_no_aesni.o \
	aes_cbc_enc_128_x4_no_aesni.o \
	aes_cbc_enc_192_x4_no_aesni.o \
	aes_cbc_enc_256_x4_no_aesni.o \
	aes128_cntr_by8_sse_no_aesni.o \
	aes192_cntr_by8_sse_no_aesni.o \
	aes256_cntr_by8_sse_no_aesni.o \
	aes_ecb_by4_sse_no_aesni.o \
	aes128_cntr_ccm_by8_sse_no_aesni.o \
	aes256_cntr_ccm_by8_sse_no_aesni.o \
	pon_sse_no_aesni.o \
	zuc_sse_no_aesni.o \
	aes_cfb_sse_no_aesni.o \
	aes128_cbc_mac_x4_no_aesni.o \
	aes256_cbc_mac_x4_no_aesni.o \
	aes_xcbc_mac_128_x4_no_aesni.o \
	mb_mgr_aes_flush_sse_no_aesni.o \
	mb_mgr_aes_submit_sse_no_aesni.o \
	mb_mgr_aes192_flush_sse_no_aesni.o \
	mb_mgr_aes192_submit_sse_no_aesni.o \
	mb_mgr_aes256_flush_sse_no_aesni.o \
	mb_mgr_aes256_submit_sse_no_aesni.o \
	mb_mgr_aes_cmac_submit_flush_sse_no_aesni.o \
	mb_mgr_aes256_cmac_submit_flush_sse_no_aesni.o \
	mb_mgr_aes_ccm_auth_submit_flush_sse_no_aesni.o \
	mb_mgr_aes256_ccm_auth_submit_flush_sse_no_aesni.o \
	mb_mgr_aes_xcbc_flush_sse_no_aesni.o \
	mb_mgr_aes_xcbc_submit_sse_no_aesni.o \
	mb_mgr_zuc_submit_flush_sse_no_aesni.o \
	ethernet_fcs_sse_no_aesni.o \
	crc16_x25_sse_no_aesni.o \
	aes_cbcs_1_9_enc_128_x4_no_aesni.o \
	aes128_cbcs_1_9_dec_by4_sse_no_aesni.o \
	mb_mgr_aes128_cbcs_1_9_submit_sse.o \
	mb_mgr_aes128_cbcs_1_9_flush_sse.o \
	mb_mgr_aes128_cbcs_1_9_submit_sse_no_aesni.o \
	mb_mgr_aes128_cbcs_1_9_flush_sse_no_aesni.o \
	crc32_refl_by8_sse_no_aesni.o \
	crc32_by8_sse_no_aesni.o \
	crc32_sctp_sse_no_aesni.o \
	crc32_lte_sse_no_aesni.o \
	crc32_fp_sse_no_aesni.o \
	crc32_iuup_sse_no_aesni.o \
	crc32_wimax_sse_no_aesni.o

#
# List of ASM modules (sse directory)
#
asm_sse_lib_objs := \
	aes128_cbc_dec_by4_sse.o \
	aes128_cbc_dec_by8_sse.o \
	aes192_cbc_dec_by4_sse.o \
	aes192_cbc_dec_by8_sse.o \
	aes256_cbc_dec_by4_sse.o \
	aes256_cbc_dec_by8_sse.o \
	aes_cbc_enc_128_x4.o \
	aes_cbc_enc_192_x4.o \
	aes_cbc_enc_256_x4.o \
	aes_cbc_enc_128_x8_sse.o \
	aes_cbc_enc_192_x8_sse.o \
	aes_cbc_enc_256_x8_sse.o \
	pon_sse.o \
	aes128_cntr_by8_sse.o \
	aes192_cntr_by8_sse.o \
	aes256_cntr_by8_sse.o \
	aes_ecb_by4_sse.o \
	aes128_cntr_ccm_by8_sse.o \
	aes256_cntr_ccm_by8_sse.o \
	aes_cfb_sse.o \
	aes128_cbc_mac_x4.o \
	aes256_cbc_mac_x4.o \
	aes128_cbc_mac_x8_sse.o \
	aes256_cbc_mac_x8_sse.o \
	aes_xcbc_mac_128_x4.o \
	md5_x4x2_sse.o \
	sha1_mult_sse.o \
	sha1_one_block_sse.o \
	sha224_one_block_sse.o \
	sha256_one_block_sse.o \
	sha384_one_block_sse.o \
	sha512_one_block_sse.o \
	sha512_x2_sse.o \
	sha_256_mult_sse.o \
	sha1_ni_x2_sse.o \
	sha256_ni_x2_sse.o \
	zuc_sse.o \
	zuc_sse_gfni.o \
	mb_mgr_aes_flush_sse.o \
	mb_mgr_aes_submit_sse.o \
	mb_mgr_aes192_flush_sse.o \
	mb_mgr_aes192_submit_sse.o \
	mb_mgr_aes256_flush_sse.o \
	mb_mgr_aes256_submit_sse.o \
	mb_mgr_aes_flush_sse_x8.o \
	mb_mgr_aes_submit_sse_x8.o \
	mb_mgr_aes192_flush_sse_x8.o \
	mb_mgr_aes192_submit_sse_x8.o \
	mb_mgr_aes256_flush_sse_x8.o \
	mb_mgr_aes256_submit_sse_x8.o \
	mb_mgr_aes_cmac_submit_flush_sse.o \
	mb_mgr_aes256_cmac_submit_flush_sse.o \
	mb_mgr_aes_cmac_submit_flush_sse_x8.o \
	mb_mgr_aes256_cmac_submit_flush_sse_x8.o \
	mb_mgr_aes_ccm_auth_submit_flush_sse.o \
	mb_mgr_aes_ccm_auth_submit_flush_sse_x8.o \
	mb_mgr_aes256_ccm_auth_submit_flush_sse.o \
	mb_mgr_aes256_ccm_auth_submit_flush_sse_x8.o \
	mb_mgr_aes_xcbc_flush_sse.o \
	mb_mgr_aes_xcbc_submit_sse.o \
	mb_mgr_hmac_md5_flush_sse.o \
	mb_mgr_hmac_md5_submit_sse.o \
	mb_mgr_hmac_flush_sse.o \
	mb_mgr_hmac_submit_sse.o \
	mb_mgr_hmac_sha_224_flush_sse.o \
	mb_mgr_hmac_sha_224_submit_sse.o \
	mb_mgr_hmac_sha_256_flush_sse.o \
	mb_mgr_hmac_sha_256_submit_sse.o \
	mb_mgr_hmac_sha_384_flush_sse.o \
	mb_mgr_hmac_sha_384_submit_sse.o \
	mb_mgr_hmac_sha_512_flush_sse.o \
	mb_mgr_hmac_sha_512_submit_sse.o \
	mb_mgr_hmac_flush_ni_sse.o \
	mb_mgr_hmac_submit_ni_sse.o \
	mb_mgr_hmac_sha_224_flush_ni_sse.o \
	mb_mgr_hmac_sha_224_submit_ni_sse.o \
	mb_mgr_hmac_sha_256_flush_ni_sse.o \
	mb_mgr_hmac_sha_256_submit_ni_sse.o \
	mb_mgr_zuc_submit_flush_sse.o \
	mb_mgr_zuc_submit_flush_gfni_sse.o \
	ethernet_fcs_sse.o \
	crc16_x25_sse.o \
	crc32_sctp_sse.o \
	aes_cbcs_1_9_enc_128_x4.o \
	aes128_cbcs_1_9_dec_by4_sse.o \
	crc32_refl_by8_sse.o \
	crc32_by8_sse.o \
	crc32_lte_sse.o \
	crc32_fp_sse.o \
	crc32_iuup_sse.o \
	crc32_wimax_sse.o \
	chacha20_sse.o

#
# List of ASM modules (avx directory)
#
asm_avx_lib_objs := \
	aes_cbc_enc_128_x8.o \
	aes_cbc_enc_192_x8.o \
	aes_cbc_enc_256_x8.o \
	aes128_cbc_dec_by8_avx.o \
	aes192_cbc_dec_by8_avx.o \
	aes256_cbc_dec_by8_avx.o \
	pon_avx.o \
	aes128_cntr_by8_avx.o \

=== perf/Makefile ===
# Copyright (c) 2017-2020, Intel Corporation
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Intel Corporation nor the names of its contributors
#       may be used to endorse or promote products derived from this software
#       without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

EXE=ipsec_perf
INSTPATH ?= /usr/include/intel-ipsec-mb.h
LIB_DIR ?= ../lib

CFLAGS = -DLINUX -D_GNU_SOURCE -DNO_COMPAT_IMB_API_053 $(INCLUDES) \
	-W -Wall -Wextra -Wmissing-declarations -Wpointer-arith \
	-Wcast-qual -Wundef -Wwrite-strings  \
	-Wformat -Wformat-security \
	-Wunreachable-code -Wmissing-noreturn -Wsign-compare -Wno-endif-labels \
	-Wstrict-prototypes -Wmissing-prototypes -Wold-style-definition \
	-pthread -fno-strict-overflow -fno-delete-null-pointer-checks -fwrapv

LDFLAGS = -fPIE -z noexecstack -z relro -z now -pthread
LDLIBS = -lIPSec_MB

ifeq ("$(shell test -e $(INSTPATH) && echo -n yes)","yes")
# library installed
CFLAGS +=
else
# library not installed
CFLAGS +=  -I../lib/include -I../lib
LDFLAGS += -L$(LIB_DIR)
endif

DEBUG_OPT ?= -O0
ifeq ($(DEBUG),y)
CFLAGS += -g -DDEBUG $(DEBUG_OPT)
LDFLAGS += -g
else
CFLAGS += -O3 -fPIE -fstack-protector -D_FORTIFY_SOURCE=2
endif

SOURCES := ipsec_perf.c msr.c
OBJECTS := $(SOURCES:%.c=%.o)

CHECKPATCH ?= checkpatch.pl
CPPCHECK ?= cppcheck

.PHONY: all clean style cppcheck

all: $(EXE)

$(EXE): $(OBJECTS)
	$(CC) $(LDFLAGS) $^ $(LDLIBS) -o $@

ipsec_perf.o: $(SOURCES)

.PHONY: clean
clean:
	-rm -f $(OBJECTS)
	-rm -f $(EXE)

SOURCES_STYLE := $(foreach infile,$(SOURCES),-f $(infile))
CHECKPATCH?=checkpatch.pl
.PHONY: style
style:
	$(CHECKPATCH) --no-tree --no-signoff --emacs --no-color \
--ignore CODE_INDENT,INITIALISED_STATIC,LEADING_SPACE,SPLIT_STRING,\
UNSPECIFIED_INT,ARRAY_SIZE,BLOCK_COMMENT_STYLE,GLOBAL_INITIALISERS,\
COMPLEX_MACRO,SPACING,STORAGE_CLASS,USE_FUNC,NEW_TYPEDEFS $(SOURCES_STYLE)

=== test/Makefile ===
#
# Copyright (c) 2012-2020, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Intel Corporation nor the names of its contributors
#       may be used to endorse or promote products derived from this software
#       without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

TEST_APP := ipsec_MB_testapp
XVALID_APP := ipsec_xvalid_test
INSTPATH ?= /usr/include/intel-ipsec-mb.h
LIB_DIR ?= ../lib

USE_YASM ?= n
YASM ?= yasm
NASM ?= nasm

CFLAGS = -MMD -DLINUX -D_GNU_SOURCE -DNO_COMPAT_IMB_API_053 \
	-W -Wall -Wextra -Wmissing-declarations -Wpointer-arith \
	-Wcast-qual -Wundef -Wwrite-strings  \
	-Wformat -Wformat-security \
	-Wunreachable-code -Wmissing-noreturn -Wsign-compare -Wno-endif-labels \
	-Wstrict-prototypes -Wmissing-prototypes -Wold-style-definition \
	-fno-strict-overflow -fno-delete-null-pointer-checks -fwrapv

YASM_FLAGS := -f x64 -f elf64 -X gnu -g dwarf2 -DLINUX -D__linux__
NASM_FLAGS := -felf64 -Xgnu -gdwarf -DLINUX -D__linux__

LDFLAGS = -fPIE -z noexecstack -z relro -z now
LDLIBS = -lIPSec_MB

ifeq ("$(shell test -r $(INSTPATH) && echo -n yes)","yes")
# library installed
CFLAGS +=
else
# library not installed
CFLAGS +=  -I../lib/include -I../lib
LDFLAGS += -L$(LIB_DIR)
endif

DEBUG_OPT ?= -O0
ifeq ($(DEBUG),y)
CFLAGS += $(DEBUG_OPT) -DDEBUG -g
LDFLAGS += -g
else
CFLAGS += -O3
endif

# ipsec_MB_testapp modules
SOURCES := main.c gcm_test.c ctr_test.c customop_test.c des_test.c ccm_test.c \
	cmac_test.c utils.c hmac_sha1_test.c hmac_sha256_sha512_test.c \
	hmac_md5_test.c aes_test.c sha_test.c chained_test.c api_test.c pon_test.c \
	ecb_test.c zuc_test.c kasumi_test.c snow3g_test.c direct_api_test.c clear_mem_test.c \
	hec_test.c xcbc_test.c aes_cbcs_test.c crc_test.c chacha_test.c poly1305_test.c \
	chacha20_poly1305_test.c null_test.c
OBJECTS := $(SOURCES:%.c=%.o)

# ipsec_xvalid_test modules
XVALID_ASM := misc.asm
XVALID_SOURCES := ipsec_xvalid.c utils.c
XVALID_OBJECTS := $(XVALID_SOURCES:%.c=%.o) $(XVALID_ASM:%.asm=%.o)

# list of present dependency files
DEP_FILES = $(wildcard ./*.d)

# rule for compiling assembly code with producing dependencies
%.o:%.asm
ifeq ($(USE_YASM),y)
	$(YASM) $(YASM_FLAGS) $< -o $@
else
	$(NASM) -MD $(@:.o=.d) -MT $@ -o $@ $(NASM_FLAGS) $<
endif

# targets come here
all: $(TEST_APP) $(XVALID_APP)

$(TEST_APP): $(OBJECTS)
	$(CC) $(LDFLAGS) $^ $(LDLIBS) -o $@

$(XVALID_APP): $(XVALID_OBJECTS)
	$(CC) $(LDFLAGS) $^ $(LDLIBS) -o $@

.PHONY: clean
clean:
	-rm -f $(OBJECTS) $(TEST_APP) $(DEP_FILES) $(XVALID_OBJECTS) $(XVALID_APP) $(ASM_OBJECTS)

# style check section
CHECKPATCH?=checkpatch.pl
CHECKPATCH_FLAGS = --no-tree --no-signoff --emacs --no-color --ignore CODE_INDENT,INITIALISED_STATIC,LEADING_SPACE,SPLIT_STRING,UNSPECIFIED_INT,ARRAY_SIZE,BLOCK_COMMENT_STYLE,GLOBAL_INITIALISERS,AVOID_EXTERNS,COMPLEX_MACRO,USE_FUNC,CONSTANT_COMPARISON,MISSING_SPACE,NEW_TYPEDEFS

%.c_style_check : %.c
	$(CHECKPATCH) $(CHECKPATCH_FLAGS) -f $<

%.h_style_check : %.h
	$(CHECKPATCH) $(CHECKPATCH_FLAGS) -f $<

%.asm_style_check : %.asm
	$(CHECKPATCH) $(CHECKPATCH_FLAGS) -f $<

%.inc_style_check : %.inc
	$(CHECKPATCH) $(CHECKPATCH_FLAGS) -f $<

SOURCES_ALL := $(wildcard *.[ch]) $(wildcard *.asm) $(wildcard *.inc)
SOURCES_STYLE := $(foreach infile,$(SOURCES_ALL),$(infile)_style_check)

.PHONY: style
style: $(SOURCES_STYLE)

# if target not clean or rinse then make dependencies
ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),style)
-include $(wildcard *.d)
endif
endif

=== debian/changelog ===
intel-ipsec-mb (0.55-1) unstable; urgency=medium

  * Sync to latest 0.55 release

 -- Colin Ian King <colin.king@canonical.com>  Wed, 28 Oct 2020 15:39:23 +0000

intel-ipsec-mb (0.53-2) unstable; urgency=medium

  * Debian/control: update compat to 13, remove compat file,
    add Rules-Requires-Root rule

 -- Colin Ian King <colin.king@canonical.com>  Sat, 4 Jul 2020 22:30:14 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,11 @@
 Source: intel-ipsec-mb
+Rules-Requires-Root: no
 Section: utils
 Priority: optional
 Maintainer: Colin Ian King <colin.king@canonical.com>
-Uploaders: Kamal Mostafa <kamal@whence.com>
-Build-Depends: debhelper (>= 12), nasm
+Build-Depends: debhelper (>= 13),
+               debhelper-compat (=13),
+               nasm
 Standards-Version: 4.1.2
 Homepage: https://github.com/intel/intel-ipsec-mb

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

DESTDIR=$$(pwd)/debian/tmp
LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
HDRDIR=/usr/include
MANDIR=/usr/share/man/man7

VERSION_MAJOR=$(shell grep -e "IMB_VERSION_STR" lib/intel-ipsec-mb.h | cut -d'"' -f2 | cut -d'.' -f1)
VERSION_MINOR=$(shell grep -e "IMB_VERSION_STR" lib/intel-ipsec-mb.h | cut -d'"' -f2 | cut -d'.' -f2)
VERSION_PATCH=$(shell grep -e "IMB_VERSION_STR" lib/intel-ipsec-mb.h | cut -d'"' -f2 | cut -d'.' -f3)

MAN1 = libipsec-mb.7
MAN2 = libipsec-mb-dev.7

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

override_dh_auto_build:
	$(shell dpkg-buildflags --export=sh); SHARED=y dh_auto_build
	find . -name "*.o" -exec rm {} \;
	$(shell dpkg-buildflags --export=sh); SHARED=n dh_auto_build

override_dh_auto_install:
	# Install the library
	find $$(pwd) -name "libIPSec_MB.so*" -exec ls -al {} \;
	install -d ${DESTDIR}${LIBDIR}
	install -m 0644 $$(pwd)/lib/libIPSec_MB.a ${DESTDIR}${LIBDIR}
	install -m 0644 $$(pwd)/lib/libIPSec_MB.so.${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH} ${DESTDIR}${LIBDIR}

	ln -s ${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH} ${DESTDIR}${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR}
	ln -s ${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR} ${DESTDIR}${LIBDIR}/libIPSec_MB.so

	#dpkg-shlibdeps ${DESTDIR}${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR}.${VERSION_MINOR}

	# Install the header files
	install -d ${DESTDIR}${HDRDIR}
	install -m 0644 $$(pwd)/lib/intel-ipsec-mb.h ${DESTDIR}${HDRDIR}

	# Install man pages
	install -d ${DESTDIR}${MANDIR}
	install -m 0444 $$(pwd)/lib/${MAN1} ${DESTDIR}${MANDIR}
	install -m 0444 $$(pwd)/lib/${MAN2} ${DESTDIR}${MANDIR}

override_dh_dwz:

%:
	dh $@
	dh_makeshlibs
	dh_shlibdeps

=== debian/watch ===
version=3
https://github.com/intel/intel-ipsec-mb/archive/v(.+).tar.gz
